ahazw = function(outcome, time1, time2 = NULL, tau, tau0 = 0, 
                  ind.ph2, m, X, Z, incl.prob = NULL, nrisk = NULL, A = NULL, eta = NULL, varest = TRUE) 
{

  if(!is.null(time2)){
    etime = time2 - time1
    otime = sort(time2[outcome==1]); otime1 = c(otime[1]-.1, otime); dtime = diff(otime1)
    Yt = t(mapply(function(x, y){as.numeric(otime > x & otime <= y)}, x = time1, y = time2))
  }
  
  if(is.null(time2)){
    etime = time1;
    otime = sort(etime[outcome==1]); otime1 = c(0, otime); dtime = diff(otime1)
    Yt = t(mapply(function(x) { as.numeric(otime <= x) }, x = etime))
  }
  
  
  N = nrow(Yt)
  nt = ncol(Yt)
  Xt = array(NA, dim = c(N, nt, ncol(X)))
  Zt = array(NA, dim = c(N, nt, ncol(Z)))
  for (j in 1:ncol(X)) {
    Xt[, , j] = sweep(Yt, 1, X[, j], "*")
  }
  for (j in 1:ncol(Z)) {
    Zt[, , j] = sweep(Yt, 1, Z[, j], "*")
  }
  evnt = apply(sweep(Yt, 1, outcome, "*"), 1, function(x) {
    ifelse(all(x == 0), 0, max(which(x == 1)))
  })
  dNt = matrix(0, N, nt)
  dNt[cbind(1:N, evnt)] = 1
  dNt = sweep(dNt, 1, outcome, "*")
  ind.ph2 = (ind.ph2 == 1)
  n = sum(ind.ph2)
  
  if (is.null(incl.prob) & is.null(nrisk) & !is.null(m)) {
    tmp = ncc.sample.prob(etime = etime, outcome = outcome, m = m)
    nrisk = tmp$nrisk
    incl.prob = tmp$incl_prob
  }

  wgt = 1/incl.prob[ind.ph2]
  if (!is.null(A)) 
    wgt = ((1/incl.prob) * exp(A %*% eta))[ind.ph2]
  XX = simplify2array(mapply(function(k) {
    wcrossprod(cbind(Yt[ind.ph2, k], Xt[ind.ph2, k, ]), wgt)
  }, k = 1:nt, SIMPLIFY = F))
  ZZ = simplify2array(mapply(function(k) {
    wcrossprod(Zt[ind.ph2, k, ], wgt)
  }, k = 1:nt, SIMPLIFY = F))
  XZ = simplify2array(mapply(function(k) {
    wcrossprod(cbind(Yt[ind.ph2, k], Xt[ind.ph2, k, ]), wgt, 
               Zt[ind.ph2, k, ])
  }, k = 1:nt, SIMPLIFY = F))
  XZdt = sweep(XZ, 3, dtime, "*")
  ZHZ = simplify2array(mapply(function(k) {
    ZZ[, , k] - (crossprod(XZ[, , k], ginv(XX[, , k])) %*% 
                   XZ[, , k])
  }, k = 1:nt, SIMPLIFY = F))
  ZdN = simplify2array(mapply(function(k) {
    wcrossprod(Zt[ind.ph2, k, ], wgt, dNt[ind.ph2, k, drop = F])
  }, k = 1:nt, SIMPLIFY = F))
  XdN = simplify2array(mapply(function(k) {
    wcrossprod(cbind(Yt[ind.ph2, k], Xt[ind.ph2, k, ]), wgt, 
               dNt[ind.ph2, k, drop = F])
  }, k = 1:nt, SIMPLIFY = F))
  ZHdN = simplify2array(mapply(function(k) {
    ZdN[, , k] - (crossprod(XZ[, , k], ginv(XX[, , k])) %*% 
                    XdN[, , k])
  }, k = 1:nt, SIMPLIFY = F))
  intZHZ = apply(sweep(ZHZ, 3, dtime, "*"), c(1, 2), sum)
  intZHdN = apply(ZHdN, c(1, 2), sum)
  gam.hat = solve(intZHZ, intZHdN)
  dBt.hat = t(mapply(function(k) {
    ginv(XX[, , k]) %*% (XdN[, , k] - XZdt[, , k] %*% gam.hat)
  }, k = 1:nt, SIMPLIFY = T))
  Bt.hat = cbind(time = otime, apply(dBt.hat, 2, cumsum))
  colnames(Bt.hat) = c("time", c("intercept", colnames(X, do.NULL = F, prefix = "X")))
    
  id.tau = max(which(otime < tau0 + tau))
  id.tau0 = ifelse(tau0!=0, max(which(otime < tau0)), 1)

  Bt.hat.tau = Bt.hat[id.tau, ] - Bt.hat[id.tau0,]
  est = c(Bt.hat.tau = Bt.hat.tau[-1], gam.hat = gam.hat)
  
  names(est) =  c(paste("Beta:", c(0, colnames(X, do.NULL = F, prefix = "X")), sep = ""),
                  paste("gamma:", colnames(Z, do.NULL = F, prefix = "Z"), sep = ""))

  se = infl = infl.omg = ind.omega = jcov.byp = sqrt.prob = NULL
  if(varest){
  XdBt = mapply(function(k) {
    cbind(Yt[ind.ph2, k], Xt[ind.ph2, k, ]) %*% dBt.hat[k,]
  }, k = 1:nt, SIMPLIFY = T)
  Zgamdt = mapply(function(k) {
    Zt[ind.ph2, k, ] %*% gam.hat * dtime[k]
  }, k = 1:nt)
  dMt = sweep(dNt[ind.ph2, ] - XdBt - Zgamdt, 1, wgt, "*")
  ZHt = simplify2array(mapply(function(k) {
    crossprod(tcrossprod(ginv(XX[, , k]), cbind(Yt[ind.ph2, k], Xt[ind.ph2, k, ])), XZ[, , k])
  }, k = 1:nt, SIMPLIFY = F))
  intZHdMi = apply(simplify2array(mapply(function(k) {
    sweep(Zt[ind.ph2, k, ] - ZHt[, , k], 1, dMt[, k], "*")
  }, k = 1:nt, SIMPLIFY = F)), c(1, 2), sum)
  if.gam = if.gam.copy = matrix(0, nrow = N, ncol = ncol(Z))
  if0.dBt = if.dBt = array(0, dim = c(N, 1 + ncol(X), nt))
  if.gam[ind.ph2, ] = if.gam.copy[ind.ph2, ] = intZHdMi %*% 
    ginv(intZHZ)
  XdM = simplify2array(mapply(function(k) {
    sweep(cbind(Yt[ind.ph2, k], Xt[ind.ph2, k, ]), 1, dMt[, k], "*")
  }, k = 1:nt, SIMPLIFY = F))
  res.dBt.gam = simplify2array(mapply(function(k) {
    tcrossprod(if.gam, XZdt[, , k])
  }, k = 1:nt, SIMPLIFY = F))
  if0.dBt[ind.ph2, , ] = simplify2array(mapply(function(k) {
    XdM[, , k] %*% ginv(XX[, , k])
  }, k = 1:nt, SIMPLIFY = F))
  if1.dBt.gam = simplify2array(mapply(function(k) {
    res.dBt.gam[, , k] %*% ginv(XX[, , k])
  }, k = 1:nt, SIMPLIFY = F))
  if.dBt[ind.ph2, , ] = simplify2array(mapply(function(k) {
    (XdM[, , k] - res.dBt.gam[ind.ph2, , k]) %*% ginv(XX[, , k])
  }, k = 1:nt, SIMPLIFY = F))

  if.eta.omg = matrix(0, nrow = N, 2)
  ZA = matrix(0, ncol(Z), 2)
  XA = array(0, dim = c(1 + ncol(X), 2, nt))
  if (!is.null(A)) {
    AA = wcrossprod(A[ind.ph2, ], wgt)
    if.eta.num = -A
    if.eta.num[ind.ph2, ] = if.eta.num[ind.ph2, ] + sweep(A[ind.ph2, ], 1, wgt, "*")
    if.eta = if.eta.num %*% ginv(AA)
    ZA = crossprod(intZHdMi, A[ind.ph2, ])
    XA = simplify2array(mapply(function(k) {
      crossprod(XdM[, , k], A[ind.ph2, ])
    }, k = 1:nt, SIMPLIFY = F))
    if.gam = if.gam.copy - if.eta %*% crossprod(ZA, ginv(intZHZ))
    if1.dBt.gam = simplify2array(mapply(function(k) {
      tcrossprod(if.gam, ginv(XX[, , k]) %*% XZdt[, , k])
    }, k = 1:nt, SIMPLIFY = F))
    if.dBt = if0.dBt - if1.dBt.gam - simplify2array(mapply(function(k) {
      if.eta %*% crossprod(XA[, , k], ginv(XX[, , k]))
    }, k = 1:nt, SIMPLIFY = F))
    if.eta.num.omg = matrix(0, nrow = N, ncol = ncol(A))
    if.eta.num.omg[ind.ph2, ] = sweep(A[ind.ph2, ], 1, wgt, "*")
    if.eta.omg = if.eta.num.omg %*% ginv(AA)
  }
  if.gam.omg = if.gam.copy - if.eta.omg %*% crossprod(ZA, ginv(intZHZ))
  if1.dBt.gam.omg = simplify2array(mapply(function(k) {
    tcrossprod(if.gam.omg, ginv(XX[, , k]) %*% XZdt[, , k])
  }, k = 1:nt, SIMPLIFY = F))
  if.dBt.omg = if0.dBt - if1.dBt.gam.omg - simplify2array(mapply(function(k) {
    if.eta.omg %*% crossprod(XA[, , k], ginv(XX[, , k]))
  }, k = 1:nt, SIMPLIFY = F))
  if.Bt.tau.omg = apply(if.dBt.omg[, , 1:id.tau], c(1, 2), 
                        sum)
  infl.omg = cbind(if.Bt.tau.omg, if.gam.omg)
  Bt.hat.tau = Bt.hat[id.tau, ]
  if0.Bt.tau = apply(if0.dBt[, , 1:id.tau], c(1, 2), sum)
  if.Bt.tau = apply(if.dBt[, , 1:id.tau], c(1, 2), sum)
  est = c(Bt.hat.tau[-1], gam.hat)
  infl = cbind(if.Bt.tau, if.gam)
  sqrt.prob = ifelse(ind.ph2, sqrt(incl.prob), 1)
  sig = crossprod(infl * sqrt.prob)
  omega = matrix(0, nrow(sig), ncol(sig))
  
  if (!is.null(m)) {
    VP = jointVP.ncc(outcome = outcome[ind.ph2], etime = etime[ind.ph2], 
                     tau = tau, m = m, incl.prob = incl.prob[ind.ph2], nrisk = nrisk[ind.ph2])
    jcov.byp = with(VP, V/P)
    ind.omega = (ind.ph2) & (outcome == 0)
    omega = crossprod(infl.omg[ind.omega, ], jcov.byp) %*% 
      infl.omg[ind.omega, ]
  }
  se = sqdg((sig + omega) * N/(N - 1))[1:(1 + ncol(X) + ncol(Z))]
  
  names(est) = names(se) = colnames(infl) =  c(paste("Beta:", c(0, colnames(X, do.NULL = F, prefix = "X")), sep = ""), 
                                  paste("gamma:", colnames(Z, do.NULL = F, prefix = "Z"), sep = ""))
  }
  
  return(list(est = est, Bt.hat = Bt.hat, se = se, infl = infl, infl.omg = infl.omg, 
              sqrt.prob = sqrt.prob, ind.omega = ind.omega, jcov.byp = jcov.byp))
}
