
\name{WeightCalibSurvival-package}
\alias{WeightCalibSurvival}
\docType{package}
\title{
  Weight Calibration for Additive Hazards and Cox Proportional Hazards Models
}
\description{
  To improve efficiency for estimating pure risks from additive hazards and 
    Cox proportional hazards models with nested case-control designs.
}
\details{
  Methods in this package are applicable to studies with some covariates that
  are only available for case-control samples nested in a cohort.
  More efficient estimates of pure risks are obtained  by calibrating the design weights
  to data available in the entire cohort. Variance estimates for the weight-calibrated estimates
  are based on explicit formulas developed in the references below.
}
\references{
  Shin YE, Pfeiffer RM Graubard BI, Gail MH. Weight calibration to
  improve efficiency for estimating pure risks from
  the additive hazards model with the nested
  case-control design. Biometrics. 2020;1-13.
  https://doi.org/10.1111/biom.13413

  Shin YE, Pfeiffer RM, Graubard BI, Gail MH. Weight calibration to improve
  the efficiency of pure risk estimates from case-control
  samples nested in a cohort. Biometrics. 2019;1-11.
  https://doi.org/10.1111/biom.13209
}

\author{
  Yei Eun Shin \email{syeeun@gmail.com}, Ruth M. Pfeiffer, Barry I. Graubard, and Mitchell H. Gail
}

\keyword{package}